<template>
  <div>
    <v-row class="gallery bordered-box">
      <v-col
        v-for="n in pictures.length"
        :key="n"
        cols="12"
        sm="3">
        <v-img
          contain
          max-height="250"
          max-width="250"
          aspect-ratio="1"
          :src="pictures[n - 1]"
          @click="toFullSize(n - 1)">
        </v-img>
      </v-col>
    </v-row>
    <div>
      <v-container>
        <v-row>
          <v-col cols="12">
            <v-pagination
              v-model="page"
              total-visible="7"
              :length="pagesTotal"
              circle
              @input="getPictures">
            </v-pagination>
          </v-col>
        </v-row>
      </v-container>
    </div>
  </div>
</template>

<script>
import { GetPicsThumbnails } from '@/api/pictures'
import { mapGetters, mapMutations } from 'vuex'

export default {
  name: 'Gallery',

  props: {
    owner: String
  },

  data() {
    return {
      page: 1,
      pagesTotal: 1,

      pictures: [],
      pictureID: []
    }
  },

  methods: {
    ...mapMutations([
      'updateLastGalleryOwner',
      'updateGalleryPage'
    ]),

    async getPictures() {
      this.updateGalleryPage(this.page)

      const response = await GetPicsThumbnails(this.page, this.owner)
      if (!response.status) {
        return
      }

      if (response.status !== 200) {
        this.$toasted.error('Oh no... Something bad happened')
      }

      this.pagesTotal = Math.ceil(parseInt(response.total) / 12)
      this.pictures = response.data
      this.pictureID = response.picID
    },

    toFullSize(pictureNumber) {
      this.$router.push({ name: 'FullPicture', query: { pictureID: this.pictureID[pictureNumber] } })
    }
  },

  computed: {
    ...mapGetters([
      'galleryPage',
      'lastGalleryOwner'
    ])
  },

  created() {
    if (this.lastGalleryOwner !== this.owner) {
      this.updateLastGalleryOwner(this.owner)
      this.updateGalleryPage(1)
    }

    this.page = this.galleryPage
    this.getPictures()
  }
}
</script>

<style>
.gallery {
  margin-left: 15% !important;
  margin-right: 15% !important;
  margin-top: 10px !important;
}

.gallery .v-image:hover {
  cursor: pointer;
}

.bordered-box {
  border-radius: 25px;
  border-style: solid;
  border-color: rgba(230, 230, 230, 1);
  background-color: rgba(247, 247, 247, 1);
  box-shadow: 0 1px 4px rgba(0, 0, 0, 0.25);
}

.v-pagination__item--active {
  background-color: rgba(51, 51, 51, 0.8) !important;
}
</style>
